program test;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  MMSystem,
  apollo in 'apollo.pas';

const
  testseeds: array[0..9] of String = ('test','hoge','Winny','V','Crescent',
      'Download','47','((( ;߄D))))޸޸ ',
      '(߁)!!!!! ','3l');
  testhashs: array[0..3] of String = ('12345678901234567890123456789012',
      'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa','͉ĂĂ܂Ȃw ',
      'nbV̕񂪓̏ꏊ');
  testmess: array[0..3] of String = ('܃}CÑeXg',
      'B悩ˁB'#13#10'SJȂ΃G@͓Ȃ',
      '̎ASĂẮH'#13#10'__',
      '^BȂ̍sɁAȋC(GA)܂悤ɁB'+
      'Ȃ͑f炵`[łBꏏɉ߂ĊyB'+
      '́AȂ̃n~OEłƂւɎv܂');

var
  i,j: Integer;
  pkey,skey,sig: String;
  tmpmes: String;
  t1,t2: Cardinal;

begin
  { TODO -oUser -cConsole Main : ̉ɃR[hLqĂ }
  Writeln('test mode(apollo512-2): 10keys * 4hashs');
  for i := 0 to 9 do
  begin
    t1 := timeGetTime;
      RSAkeycreate512(pkey,skey,testseeds[i]);
    t2 := timeGetTime;
    Writeln;
    Writeln('KeyGenerator: ',testseeds[i]);
    Writeln('PublicKey = ',pkey);
    Writeln('SecretKey = ',skey);
    Writeln('Trip = ',triphash(pkey));
    Writeln('making time = ',IntToStr(t2-t1),'ms');
    Writeln;
    Writeln('#sign test');
    t1 := timeGetTime;
      for j := 0 to 3 do
      begin
        sig := RSAsign(testhashs[j],pkey,skey);
        Writeln(' hash = ',testhashs[j]);
        Writeln(' Signature = ',sig);
        if RSAverify(testhashs[j],sig,pkey) then
          Writeln('  True')
        else
          Writeln('  False');
        sig[1] := '*';
        Writeln(' BrokenSignature = ',sig);
        if RSAverify(testhashs[j],sig,pkey) then
          Writeln('  True')
        else
          Writeln('  False');
        Writeln;
      end;
    t2 := timeGetTime;
    Writeln('signtest time = ',IntToStr(t2-t1),'ms');
    Writeln('#crypt test');
    t1 := timeGetTime;
      for j := 0 to 3 do
      begin
        tmpmes := RSAencrypt(testmess[j],pkey);
        Writeln(' original = ',testmess[j]);
        Writeln(' Cryptmessage = ',tmpmes);
        tmpmes := RSAdecrypt(tmpmes,pkey,skey);
        Writeln(' Decryptmessage = ',tmpmes);
        Writeln;
      end;
    t2 := timeGetTime;
    Writeln('crypttest time = ',IntToStr(t2-t1),'ms');
  end;
  Writeln('test mode(apollo1024-3): 10keys * 4hashs');
  for i := 0 to 9 do
  begin
    t1 := timeGetTime;
      RSAkeycreate1024(pkey,skey,testseeds[i]);
    t2 := timeGetTime;
    Writeln;
    Writeln('KeyGenerator: ',testseeds[i]);
    Writeln('PublicKey = ',pkey);
    Writeln('SecretKey = ',skey);
    Writeln('Trip = ',triphash(pkey));
    Writeln('making time = ',IntToStr(t2-t1),'ms');
    Writeln;
    Writeln('#sign test');
    t1 := timeGetTime;
      for j := 0 to 3 do
      begin
        sig := RSAsign(testhashs[j],pkey,skey);
        Writeln(' hash = ',testhashs[j]);
        Writeln(' Signature = ',sig);
        if RSAverify(testhashs[j],sig,pkey) then
          Writeln('  True')
        else
          Writeln('  False');
        sig[1] := '*';
        Writeln(' BrokenSignature = ',sig);
        if RSAverify(testhashs[j],sig,pkey) then
          Writeln('  True')
        else
          Writeln('  False');
        Writeln;
      end;
    t2 := timeGetTime;
    Writeln('signtest time = ',IntToStr(t2-t1),'ms');
    Writeln('#crypt test');
    t1 := timeGetTime;
      for j := 0 to 3 do
      begin
        tmpmes := RSAencrypt(testmess[j],pkey);
        Writeln(' original = ',testmess[j]);
        Writeln(' Cryptmessage = ',tmpmes);
        tmpmes := RSAdecrypt(tmpmes,pkey,skey);
        Writeln(' Decryptmessage = ',tmpmes);
        Writeln;
      end;
    t2 := timeGetTime;
    Writeln('crypttest time = ',IntToStr(t2-t1),'ms');
  end;
end.
